<?
require( "../userdata/config.php" );
require( SMARTY_DIR . "Smarty.class.php" );
require( "classMysql.php" );
require( "classMySmarty.php" );
require( "classTextile.php" );
require( "functions.php" );

$db = new DB_mysql;
$tt = new Textile;

/* path thingi */
initVar( "path", "");
$p = explode( "/", $path );

/* remove empty elemets from the end */
for( $i = count( $p ); trim( $p[ $i - 1 ] ) == "" && array_key_exists( $i - 1, $p ); --$i ) array_pop( $p );


/* Language thingi */

$lang = getSetting( "default_language" );
if( $p[0] != "" )
  $lang = $p[0];

$db->query( "SELECT * FROM `languages`" );
$i = 0;
while ($db->next_record()) {
  $lang_urls[] = "/" . $db->f( "lang" ) . "/" . $db->f( "default_site" ) . "/";
  $lang_names[] = $db->f( "name" );
  $lang_imgs[] = $db->f( "src_img" );
  $lang_shorts[] = $db->f( "lang" );
  $lang_defaults[] = $db->f( "default_site" );
  if( $lang == $db->f( "lang" )) {
    $lang_selected = $i;
    $default_site = $db->f( "default_site" );
    require( "lang_" . $lang . ".php" );
  }
  $i++;
}

if( !isset( $lang_selected )) {
  $lang = getSetting( "default_language" );
  require( "lang_" . $lang . ".php" );
}

/* parse path and site name */
$site_path = implode( "/", array_slice( $p, 1, count( $p ) - 2 )) . "/";
if( $p[1] != "" ) {
  $site_name = $p[ count( $p ) - 1 ];
} else {
  $site_name = $default_site;
}

/* Build Menu */
$m_path = "/";
foreach( $p as $i => $p_item ) {
  if( $i != 0 ) $m_path .= "/" . $p_item;
  $m_path = makeCleanPath( $m_path );
  $db->query( "SELECT `href`, `name` FROM `menu` " .
              "WHERE `lang` = '" . $lang . "' ".
              "AND `path` = '" . $m_path . "' ".
              "ORDER BY `id`;" );
  $menu_selected[ $i ] = -1;
  for( $k = 0; $db->next_record(); $k++ ) {
    if( (strpos( $db->f( "href" ), '/')) === TRUE ) {
      $menu_urls[ $i ][] = $db->f( "href" );
    } else {
      if( $m_path == "/" ) {
        $f_name = $m_path;
      } else {
        $f_name = "/" . makeCleanPath( $m_path );
      }
      $menu_urls[ $i ][] = "/" . $lang . $f_name . replaceWhitespace( $db->f( "href" )) . "/";
    }
    $menu_names[ $i ][] = $db->f( "name" );
    if( $p[$i+1] == $db->f( "href" )) {
      $menu_selected[ $i ] = $k;
    }
  }
}

/* Load Module */
if( file_exists( "mod_" . $p[1] . ".php" )) {
  require( "mod_" . $p[1] . ".php" );
  $content = call_user_func( "mod_" . $p[1], $p );
} else {
  /* Get Site */
  $db->query( "SELECT `id`, `content_cached` FROM `sites` " .
              "WHERE `name` = '" . $site_name . "' ".
              "AND `path` = '" . $site_path . "' " .
              "AND `language` = '" . $lang . "';" );

  if( $db->next_record( )) {
    $db->query( "UPDATE `sites` SET `count`=`count`+1 " .
                "WHERE `path` = '" . $site_path . "'" .
                "AND `name` = '" . $site_name . "'" .
                "AND `language` = '" . $lang . "';");
    $content = $db->f( "content_cached");
    $ctemplate = new mySmarty;
    $ctemplate->assign( "content", $content );
    $ctemplate->assign( "pagetitle", $site_name );
    $content = $ctemplate->fetch( "content.tpl" );
  } else {
    if( !$xerr )
      $xerr = $itext[ "site_not_found" ];
  }
}

if( $xerr ) {
  getSmarty( );
  $smarty->assign( "error", $xerr );
  $content = $smarty->fetch( "error.tpl" );

}

/* highlighing */
initVar( "highlight", 0 );
if( $highlight ) {
  preg_match_all( "/(<[^>][^<]*>)([^<]*)/", $content, $tmp_match, PREG_PATTERN_ORDER );
  $content = "";
  for( $h_num = 0; $h_num < count( $tmp_match[1] ); $h_num++ ) {
    $content .= $tmp_match[1][ $h_num ];
    $content .= str_replace( $highlight, "<span class=\"highlight\">" . $highlight . "</span>", $tmp_match[2][ $h_num ] );
  }
}

getSmarty( );
$smarty->assign( "pagetitle", $site );
$smarty->assign( "lang", $lang );
$smarty->assign( "lang_urls", $lang_urls );
$smarty->assign( "lang_names", $lang_names );
$smarty->assign( "lang_imgs", $lang_imgs );
$smarty->assign( "lang_selected", $lang_selected );
$smarty->assign( "menu_urls", $menu_urls );
$smarty->assign( "menu_names", $menu_names );
$smarty->assign( "menu_selected", $menu_selected );
$smarty->assign( "content", $content );
$smarty->display( "main.tpl" );

?>
